#include <File.au3>
#include <Typos.au3>
#include <Array.au3>

#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <ProgressConstants.au3>
#include <WindowsConstants.au3>

#cs
1.0 = * Initial release.
#ce

Global $Version = "1.0"
Global $MediaDestination = "UNKNOWN"

Local $aArray_RomsListCleaned[0][3]
Local $aArray_SourceListCleaned[0][2]
Local $aArray_FinishedList[0][5]

HotKeySet("+{ESC}", "_Quit")

MsgBox(0, "Tur-Matcher " & $Version & " by Turranius", "We will now ask you a number of questions." & @CRLF & @CRLF & "Please see the title of each box that pops up for what we are asking for." & @CRLF & @CRLF & "You can press Shift-Escape at any time to quit/abort (if there is a messagebox up, you have to click on it before it exits).")

$Reply = MsgBox(32 + 4, "Use XML?", "Do you want to use an XML (database) or just use your Roms as source?" & @CRLF & @CRLF & "Press Yes for XML file or No for Roms")

If $Reply = "6" Then
;   $RomXML = "I:\Arcade\HyperSpin\Databases\Commodore 64\Commodore 64.xml"
	Global $RomXML = FileOpenDialog("Select Database XML", "", "XML files (*.XML)", 1)
	If $RomXML = "" Then
	  MsgBox(16, "Error", "Got no XML location. Aborting")
	  Exit
   EndIf
Else
   $RomXML = ""
;   $RomFolder = "I:\Arcade\Roms\Commodore 64"
   Global $RomFolder = FileSelectFolder("Please browse to the rom folder you want to use for sourcenames.", "")
   If $RomFolder = "" Then
	  MsgBox(16, "Error", "Got no Rom location. Aborting")
	  Exit
   EndIf
EndIf

Global $HitLimit = ""
$HitLimit = InputBox("Threshold", "Enter the number differences that constitutes a match. Setting this too high will get false positives. Setting it to 0 will be exact match only", "2")
If $HitLimit = "" Then
   Exit
EndIf

Global $AutoCopyLimit = ""
$AutoCopyLimit = InputBox("AutoCopy Threshold", "Enter the threashhold to use for automatic copy without questions. 0 = Only exact matches. -1 = Disable Autocopy", "0")
If $AutoCopyLimit = "" Then
   Exit
EndIf

;$SourceFolder = "I:\Arcade\Others\Commodore 64 offical vids\Video"
Global $SourceFolder = FileSelectFolder("Please browse to the source folder for media.", "")

If $SourceFolder = "" Then
   MsgBox(16, "Error", "Got no location. Aborting")
   Exit
EndIf

;$DestinationFolder = "I:\Arcade\HyperSpin\Media\Commodore 64\Video"
Global $DestinationFolder = FileSelectFolder("Please browse to the destination folder for media.", "")

If $DestinationFolder = "" Then
   MsgBox(16, "Error", "Got no location. Aborting")
   Exit
EndIf

If $SourceFolder = $DestinationFolder Then
   MsgBox(16, "Error", "Source and Destination folders can not be the same.")
   Exit
EndIf

If $RomXML = "" Then ; User selected to use Roms as RomList, not the XML
   TrayTip("Indexing Roms. Hang on. This might take a minute or so.", "" , 60)
   $RomsList = _FileListToArray($RomFolder  & "\")
   If @error = 1 Then
	  MsgBox(0, "", "No Files Found in " & $RomFolder & "\")
	  Exit
   EndIf
   $Matched = "0"
   TrayTip("Indexing Roms", "Hang on a second or two.",5)
   For $i = 1 To $RomsList[0]
	  $RomName = $RomsList[$i]
	  $RomNameNoExt = RemoveExtRegExp($RomName)
	  $RomNameClean = StringRegExpReplace($RomNameNoExt, '\(.*\)', '') ; Removes (*)
	  $RomNameClean = StringRegExpReplace($RomNameClean, '\[.*\]', '') ; Removes [*]
	  $RomNameClean = StringStripWS($RomNameClean, 7)
	  _ArrayAdd($aArray_RomsListCleaned, $RomName & "|" & $RomNameClean & "|" & $RomNameNoExt )
   Next

Else ; User selected to use a XML file as RomList.
   ;msgbox(0, "Reading XML:", $RomXML)

   Local $hFileOpen = FileOpen($RomXML, 0)
   If $hFileOpen = -1 Then
	  MsgBox(16, "", "An error occurred when reading the XML file.")
	  Exit
   EndIf

   $Rows = _FileCountLines($RomXML)
   For $i = 1 to $Rows

	  $line = FileReadLine($hFileOpen, $i)
	  If StringinStr($line, "<game name=") Then
		 Local $GameNameArray = StringSplit($line, '"')
		 $GameName = $GameNameArray[2]
		 If $GameName <> "" Then
			$GameNameClean = StringRegExpReplace($GameName, '\(.*\)', '') ; Removes (*)
			$GameNameClean = StringRegExpReplace($GameNameClean, '\[.*\]', '') ; Removes [*]
			;msgbox(0,$GameNameClean,'the line ' & $i & ' is ' & $GameName)
			_ArrayAdd($aArray_RomsListCleaned, $GameName & "|" & $GameNameClean & "|" & $GameName )
			ConsoleWrite(StringFormat($GameName & "\n"))
			TrayTip("Indexing XML file", "Row " & $i & "/" & $Rows,5)
		 EndIf
	  EndIf
   Next
   TrayTip("Indexing XML file", "Row " & $Rows & "/" & $Rows,5)
   FileClose($hFileOpen)

EndIf
_ArraySort($aArray_RomsListCleaned)
_ArrayDisplay($aArray_RomsListCleaned, "Roms found. Close this window on the upper X to continue.","",16,-1,"Rom Name|Rom Name Cleaned|Rom Name No Extensions")

$SourceList = _FileListToArray($SourceFolder  & "\")

For $i = 1 To $SourceList[0]
   $SourceName = $SourceList[$i]
   $SourceNameNoExt = RemoveExtRegExp($SourceName)
   $SourceNameClean = StringRegExpReplace($SourceNameNoExt, '\(.*\)', '') ; Removes (*)
   $SourceNameClean = StringRegExpReplace($SourceNameClean, '\[.*\]', '') ; Removes [*]
   $SourceNameClean = StringStripWS($SourceNameClean, 7)
   _ArrayAdd($aArray_SourceListCleaned, $SourceName & "|" & $SourceNameClean )
Next
_ArraySort($aArray_SourceListCleaned)
_ArrayDisplay($aArray_SourceListCleaned, "Sources Found. Close this window on the upper X to continue.","",32,-1,"Source Name|Source Name Cleaned")

$Runs = 0
$RomsToCheck = UBound($aArray_RomsListCleaned)
For $i = 0 To $RomsToCheck - 1
   $Skip = "FALSE"
   $RomNameNoExtension = $aArray_RomsListCleaned[$i][2]
   If FileExists($DestinationFolder & "\" & $RomNameNoExtension & ".*") Then
	  ConsoleWrite(StringFormat("Skipping " & $RomNameNoExtension & " as it already exists in " & $DestinationFolder & "\n" ))
	  $Skip = "TRUE"
   EndIf

   If $Skip = "FALSE" Then
   $Runs = $Runs + 1
	  ;If $Runs > "100" Then
		 ;ExitLoop
	  ;EndIf
	  $ExactHit = "FALSE"
	  $bestMatch = ""
	  $bestMatchIdx = ""
	  $RomName = $aArray_RomsListCleaned[$i][0]
	  $RomNameClean = $aArray_RomsListCleaned[$i][1]

	  Local $test_word = $RomNameClean
	  ConsoleWrite(StringFormat($Runs & ": Checking " & $test_word & " -> "))
	  Local $bestMatch = StringLen($test_word), $bestMatchIdx, $typos
	  For $k = 0 To UBound($aArray_SourceListCleaned) - 1
		 $typos = _Typos($aArray_SourceListCleaned[$k][1], $test_word)
		 If $typos > 0 Then
			If $typos < $bestMatch Then
			   $bestMatch = $typos
			   $bestMatchIdx = $k
			EndIf
		 Else ; Exact match found!
			$bestMatchIdx = $k
			$bestMatch = $typos
			$ExactHit = "TRUE"
		 EndIf
	  Next

	  ; Nothing found...
	  If $bestMatchIdx = "" AND $ExactHit = "FALSE" Then
		 $bestMatchIdx = "NA"
		 $BestMatchName = "Nothing"
		 $bestMatch = "Nothing"
		 ConsoleWrite(StringFormat("No hit for " & $RomName & "\n"))
		 TrayTip("No hit for " & $test_word, "",5)
	  Else
		 $BestMatchName = $aArray_SourceListCleaned[$bestMatchIdx][0]
		 $BestMatchNameCleaned = $aArray_SourceListCleaned[$bestMatchIdx][1]
		 ConsoleWrite(StringFormat("Best match : " & $BestMatchName & " (" & $bestMatchIdx & ") with " & $bestMatch & " spelling errors\n"))
		 TrayTip($i & "/" & $RomsToCheck & " - Best match for " & $test_word, $BestMatchName & " (" & $bestMatch & ")",5)
		 If $HitLimit +1 > $bestMatch Then
			_ArrayAdd($aArray_FinishedList, $RomNameClean & "|" & $BestMatchNameCleaned & "|" & $RomName & "|" & $BestMatchName & "|" & $bestMatch )

			$BestMatchNameExt = _FileGetExt($BestMatchName)

			If $AutoCopyLimit >= $bestMatch Then
			   ConsoleWrite(StringFormat("Autocopy: " & $SourceFolder & "\" & $BestMatchName & "  ->  " & $DestinationFolder & "\" & $RomNameNoExtension & $BestMatchNameExt & "\n"))
			   FileCopy($SourceFolder & "\" & $BestMatchName, $DestinationFolder & "\" & $RomNameNoExtension & $BestMatchNameExt)
			Else
			   $Reply = MsgBox(3 + 32, "Is this a match?", "Would you say that these match?" & @CRLF & @CRLF & $RomNameClean & @CRLF & $BestMatchNameCleaned & @CRLF & @CRLF & "Exact names are:" & @CRLF & $RomName & @CRLF & $BestMatchName & @CRLF & @CRLF & "Misspellings: " & $bestMatch)
			   If $Reply = "2" Then
				  Exit
			   EndIf
			   If $Reply = "7" Then
				  ConsoleWrite(StringFormat("Skipping: " & $BestMatchName & "\n"))
			   EndIf
			   If $Reply = "6" Then
				  ConsoleWrite(StringFormat("Manual copy: " & $SourceFolder & "\" & $BestMatchName & "  ->  " & $DestinationFolder & "\" & $RomNameNoExtension & $BestMatchNameExt & "\n"))
				  FileCopy($SourceFolder & "\" & $BestMatchName, $DestinationFolder & "\" & $RomNameNoExtension & $BestMatchNameExt)
			   EndIf

			EndIf

		 EndIf
	  EndIf

   EndIf
Next
_ArrayDisplay($aArray_FinishedList, "All done. Here are the final results.","",16,-1,"Rom Name Clean|Source Match Clean|Rom Full Name|Source Match Full Name|Misspellings")

Func RemoveExtRegExp($Input)
   Return StringRegExpReplace($Input, "\.[^.]*$", "")
EndFunc

Func _FileGetExt($sPath)
    Local $NULL, $sExt
    _PathSplit($sPath, $NULL, $NULL, $NULL, $sExt)
    Return $sExt
EndFunc

 ; This function is called whenever you quit the script.
Func _Quit()
   Exit
EndFunc   ;==>_Quit